/* $Id: purge.sql,v 1.1 2006/07/06 07:56:02 pepm01a Exp $ */

use mondb
go

if object_id('purgeMDAdata') != NULL
begin
    print "Dropping proc purgeMDAdata"
    drop proc purgeMDAdata
end
go

create proc purgeMDAdata
( @retention	int	= 30
)
as
declare @rowz int
      , @errz int
      , @cutoff datetime
      , @rowcnt int

if exists (select * from master..sysprocesses where object_name(id, dbid) = 'purgeMDAdata' and spid != @@spid)
begin
    print "purgeMDAdata is already running"
    return 0
end

select @cutoff = dateadd(dd, -@retention, getdate())

delete from monDeviceIO
 where servername = @@servername
   and runDate < @cutoff

select @rowz = @@rowcount
     , @errz = @@error

if @errz != 0
begin
    raiserror 99999 "delete from monDeviceIO failed"
end

delete from monEngine
 where servername = @@servername
   and runDate < @cutoff

select @rowz = @@rowcount
     , @errz = @@error

if @errz != 0
begin
    raiserror 99999 "delete from monEngine failed"
end

delete from monNetworkIO
 where servername = @@servername
   and runDate < @cutoff

select @rowz = @@rowcount
     , @errz = @@error

if @errz != 0
begin
    raiserror 99999 "delete from monNetworkIO failed"
end

-- for monProcess* tables we keep 1/4th of the other stuff
-- as the level of detail is very big...

select @cutoff = dateadd(dd, -(@retention/4), getdate())


select @rowz = 10000
set rowcount @rowz

while @rowz > 0
begin
    delete from monProcessActivity
     where servername = @@servername
       and runDate < @cutoff

    select @rowz = @@rowcount
         , @errz = @@error

    if @errz != 0
    begin
        raiserror 99999 "delete from monProcessActivity failed"
    end
end

select @rowz = 10000
while @rowz > 0
begin
    delete from monProcessWaits
     where servername = @@servername
       and runDate < @cutoff

    select @rowz = @@rowcount
         , @errz = @@error

    if @errz != 0
    begin
        raiserror 99999 "delete from monProcessWaits failed"
    end
end


select @rowz = 10000
while @rowz > 0
begin
    delete from monProcessWaits
     where servername = @@servername
       and runDate < getdate()
       and WaitEventID = 250 -- incoming network data

    select @rowz = @@rowcount
         , @errz = @@error

    if @errz != 0
    begin
        raiserror 99999 "delete from monProcessWaits failed"
    end
end

select @cutoff = dateadd(dd, -2, getdate())
select @rowz = 50000
while @rowz > 0
begin
    delete from monOpenObjectActivity
     where servername = @@servername
       and runDate < @cutoff

    select @rowz = @@rowcount
         , @errz = @@error

    if @errz != 0
    begin
        raiserror 99999 "delete from monOpenObjectActivity failed"
    end
end


set rowcount 0

go

if object_id('purgeMDAdata') != NULL
begin
    print "Created proc purgeMDAdata"
end
else
begin
    print "FAILED: creat proc purgeMDAdata"
end
go
