/*$Id: purge_threshold_proc.sql,v 1.1 2006/07/06 07:56:02 pepm01a Exp $ */

-- threshold action proc for mondb
-- Michael Peppler, 10/3/2005

use mondb
go


if object_id('mda_threshold_purge') != null
begin
    print "Dropping proc mda_threshold_purge"
    drop proc mda_threshold_purge
end
go


create procedure mda_threshold_purge
    @dbname varchar(30),
    @segmentname varchar(30),
    @free_space int,
    @status int
as
declare @devname varchar(100),
           @before_size int, 
           @after_size int,
           @before_time datetime,
           @after_time datetime,
           @error int,
           @env varchar(20)


/*
** if the segment is the logsegment, dump the log
** log segment is always "2" in syssegments
*/
if @segmentname = (select name from syssegments
               where segment = 2)
begin
-- if it's a log segment then call the normal threshold action proc.
    exec sp_thresholdaction @dbname, @segmentname, @free_space, @status
    return 0
end 

raiserror 99999 "THRESHOLD WARNING: database '%1!', segment '%2!' at '%3!' pages", @dbname, @segmentname, @free_space

print "THRESHOLD WARNING: executing purgeMDAdata"

exec purgeMDAdata

go

if object_id('mda_threshold_purge') != null
begin
    print "Created proc mda_threshold_purge"
end
else
begin
    print "Created proc mda_threshold_purge"
end
go
